<?php
/**
 * @package	Hikashop UPI payment Plugin
 * @version	1.0.0
 * @author	HikaShop
 * @copyright	(C) 2010-2022 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
	class plgHikashopPaymentUpi extends hikashopPaymentPlugin {

		var $multiple = true;
		var $name = 'upi';
		var $accepted_currencies = array(
			'INR'
		);

		var $pluginConfig = array(
			'name' => array('Your merchant name','input'),
			'upi_address' => array('Your merchant UPI address','input'),
			'return_url' => array('RETURN_URL','input'),
		);

		function onAfterOrderConfirm(&$order, &$methods, $method_id) {

			parent::onAfterOrderConfirm($order, $methods, $method_id);

			if (empty($this->payment_params->name)) {
				$this->app->enqueueMessage('You have to configure a name for the UPI payment method first. Check your payment method\'s parameters on the backend first.');
				return false;
			} elseif (empty($this->payment_params->upi_address)) {
				$this->app->enqueueMessage('You have to configure a UPI address for the UPI payment method first. Check your payment method\'s parameters on the backend first.');
				return false;
			}
			$return_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id='.$order->order_id . $this->url_itemid;
			$this->vars = array();
			$this->vars['order_number'] = $order->order_number;
			$this->vars['amount'] = number_format($order->cart->full_total->prices[0]->price_value_with_tax,2,'.','');
			$this->vars['URL'] = "upi://pay?pn=".urlencode($this->payment_params->name)."&pa=".$this->payment_params->upi_address.'&cu=INR&am='.$this->vars['amount'].'&tr='.urlencode($order->order_number).'&url='.urlencode($return_url);
			$this->vars['QR'] = 'https://quickchart.io/qr?ecLevel=M&margin=1&text='.urlencode($this->vars['URL']);

			return $this->showPage('end');

		}

		function getPaymentDefaultValues(&$element) {
			$element->payment_name='UPI';
			$element->payment_description='You can pay using UPI.';
			$element->payment_images='';
		}
	}
